<?php
if ( !defined( 'ABSPATH' ) ) exit;

if ( !class_exists( 'rbytbAdminfunction' ) ) {

class rbytbAdminfunction {
	
public $table_list =  'table_master';	
public $table_booking = 'booking_master';
public $defaultVal = '';
public function rbytbAdminfunction(){
 $defaultVal = unserialize(get_option('rbytb_default'));
}	
 
 public function tableList($n,$o){
	global $wpdb;
	$ord = '';
	if(!empty($n)){
		$ord =  " ORDER BY ".$n.' ' .$o;
	}	
	$results = $wpdb->get_results("SELECT * FROM ".$wpdb->prefix.$this->table_list.$ord);
	//print_r($wpdb->last_query);
	return $results;
	
 }
 
 public function changeTableStatus($i,$s){
	global $wpdb;
	if(!empty($i)){
		$results = $wpdb->get_results("UPDATE ".$wpdb->prefix.$this->table_list." SET is_active =".$s." Where id=".$i);
		wp_redirect('?page=tbl-list');
	}	
 }
 
 public function deleteTable($i){
	global $wpdb;
	if(!empty($i)){
		$results = $wpdb->get_results("DELETE FROM ".$wpdb->prefix.$this->table_list." Where id=".$i);
		wp_redirect('?page=tbl-list');
	} 
 }
 
 public function changeBookingStatus($i,$s){
	global $wpdb;
	if(!empty($i)){
		$results = $wpdb->get_results("UPDATE ".$wpdb->prefix.$this->table_booking." SET is_status =".$s." Where id=".(int)$i);
		if($s == 1 && !empty($i)){
			$this->sendMailtoCustomer($i);
		} else if($s == 3 && !empty($i)){
			$this->sendMailtoCustomer($i,'rejected');
		}
		wp_redirect('?page=tbl-bookings');
	}	
 }
 
 public function deleteBooking($i){
	global $wpdb;
	if(!empty($i)){
		$results = $wpdb->get_results("UPDATE FROM ".$wpdb->prefix.$this->table_booking." Where id=".$i);
		wp_redirect('?page=tbl-bookings');
	} 
 }
 
 
 
 public function getto2BookedTable($dt,$tm){
	 global $wpdb;
	 $tableList = array();
	 if(!empty($dt)){
		$results = $wpdb->get_results("SELECT vc_table_seat FROM ".$wpdb->prefix.$this->table_booking." Where dt_date='".$dt."' AND vc_time = '".$tm."'");
		foreach($results as $tbl){
			$tbspt = explode(',',$tbl->vc_table_seat);
			foreach($tbspt as $septd){ 
				$tblData = explode('_',$septd);
				if(!is_array($tableList[$tblData[0]])){
					$tableList[$tblData[0]] = array();
				}
				array_push($tableList[$tblData[0]],$tblData[1]);
			}
		}
		return $tableList;
	} 
 }
 
 public function vacanttableList(){
	global $wpdb;
		$results = $wpdb->get_results("SELECT * FROM ".$wpdb->prefix.$this->table_list." where is_active =1");
	//print_r($wpdb->last_query);
	return $results;	
 }
 
 public function bookTable($post){
	 global $wpdb;
	 $bookingDate = sanitize_text_field($post['bookingdate']);
	 $bookingTime = sanitize_text_field($post['tm1']);
	 $numberofperson = sanitize_text_field($post['numberofpersons']);
	 $personName = sanitize_text_field($post['person_name']);
	 $personEmail = sanitize_text_field($post['email']);
	 $personPhone = sanitize_text_field($post['phone']);
	 $table_s = sanitize_text_field($post['bkdtbl']);
	 $status = 1;
	 $isDuplicate = false;
	 if($this->checkBookedTableSeat($bookingDate,$bookingTime,$table_s)){
		 $status = '2';
		 $isDuplicate = true;
	 }
	 $wpdb->insert($wpdb->prefix.'booking_master',array(
		'vc_name'     => $personName,
        'vc_email'    => $personEmail,
        'vc_phone' => $personPhone,
        'vc_table_seat'   => $table_s,
        'vc_time'   => $bookingTime,
        'int_person_no'   => $numberofperson,
        'dt_date'   => $bookingDate ,      
        'is_status'   => $status       
	 ));
	 $lastid = $wpdb->insert_id;
   if($defaultVal['aut_conf'] && !$isDuplicate){
	 $this->sendMailtoCustomer($lastid);	 	
   }
	 $this->sendMailtoAdmin($personName,$personEmail,$personPhone,$table_s,$bookingDate,$bookingTime,$numberofperson,$isDuplicate);   
	 $url = implode('?',$_SERVER['REQUEST_URI']);
	 wp_redirect($url[0].'?success');
	 exit;
  }
  public function checkBookedTableSeat($dt,$tm,$bookSeat){
	  global $wpdb;
	  $results = $wpdb->get_results("SELECT vc_table_seat FROM ".$wpdb->prefix.$this->table_booking." Where dt_date='".$dt."' AND vc_time = '".$tm."'");
		foreach($results as $tbl){
			$tbspt = explode(',',$tbl->vc_table_seat);
			$bookedseat = explode(',',$bookSeat);			
			$getduplicateseat = array_intersect($tbspt,$bookedseat);
			if(!empty(count($getduplicateseat))){
				return true;
			}
		}
		return false;
  }
  
  public function UpdatebookTable($post){
	 global $wpdb;
	 $bookingDate = sanitize_text_field($post['bookingdate']);
	 $bookingTime = sanitize_text_field($post['tm1']);
	 $numberofperson = sanitize_text_field($post['numberofpersons']);
	 $personName = sanitize_text_field($post['person_name']);
	 $personEmail = sanitize_text_field($post['email']);
	 $personPhone = sanitize_text_field($post['phone']);
	 $table_s = sanitize_text_field($post['bkdtbl']);
	 $id = sanitize_text_field($post['bktbl_id']);
	 $wpdb->update($wpdb->prefix.'booking_master',array(
		'vc_name'     => $personName,
        'vc_email'    => $personEmail,
        'vc_phone' => $personPhone,
        'vc_table_seat'   => $table_s,
        'vc_time'   => $bookingTime,
        'int_person_no'   => $numberofperson,
        'dt_date'   => date('y-m-d',strtotime($bookingDate))       
	 ),array('id' => $id));
	  //$this->sendMailtoCustomer($id);	 
	  //$this->sendMailtoAdmin($personName,$personEmail,$personPhone,$table_s,$bookingDate,$bookingTime,$numberofperson);
	  $url = implode('?',$_SERVER['REQUEST_URI']);
	 wp_redirect($url[0].'?page=tbl-bookings');
	 exit;
  }
  
  public function sendMailtoCustomer($id,$type='success'){
	  if(!empty($id)){
		  
		  $subject = $this->$defaultVal['conf_sub'];
		  $message = $this->$defaultVal['conf_msg'];
		  if($type == 'rejected'){
			  $subject = $this->$defaultVal['rejected_sub'];
			  $message = $this->$defaultVal['rejected_msg'];
		  }
		  $tableList = array();
		  $msg = '';
		  $getTableDet = $rybtb_controller->fun->tableBookingRow($id);
		  $tbspt = explode(',',$getTableDet->vc_table_seat);
			foreach($tbspt as $septd){ 
				$tblData = explode('_',$septd);
				if(!is_array($tableList[$tblData[0]])){
					$tableList[$tblData[0]] = array();
				}
				array_push($tableList[$tblData[0]],$tblData[1]);
			}
		  foreach($tableList as $key=>$val) {
			 $tbl = $rybtb_controller->fun->getTableName($key);
			 $tableName.= $tbl->vc_name.' - '. implode(',',$val) .'<\n>';
		  }
		 $msg = str_replace('{user_name}',$getTableDet->vc_name,$message);
		 $msg = str_replace('{Table_details}',$tableName,$msg);
		 $msg= str_replace('{DATE}',date('d-m-Y',strtotime($getTableDet->dt_date)),$msg);
		 $msg= str_replace('{TIME}',$getTableDet->vc_time,$msg);
		 $msg= str_replace('{No_of_Person}',$getTableDet->int_person_no,$msg);
		 $msg= str_replace('{site_link}',get_option('siteurl'),$msg);
		 $msg= str_replace('{current_time}',date('h:i:s'),$msg);
		 $to = $getTableDet->vc_email;
		 $admemail = get_option('admin_email');
		 $admname = get_option('blogname');
		 $headers = 'From: '. $admname .' <'. $admemail .'>' . "\r\n";
		  wp_mail( $to, $subject, $msg, $headers, $attachments );
		  $this->updatebookingStatus($id);
		  
	  }
  }  

  
  public function sendMailtoAdmin($name,$email,$phone,$seat,$date,$time,$nop,$isDuplicate){
	      $msgsent = " Confirmed Mail Sent to the customer.";
	      if($isDuplicate){
			  $duplicate = ' With Duplicate Table Seat on same time.';
			  $msgsent = " Conformation Mail Not sent to the customer.Please confirm manually.";
		  }
		  $subject = "New Table Booking Conformation";
		  $siteName = get_option( 'blogname' );
		  $tbspt = explode(',',$seat);
			foreach($tbspt as $septd){ 
				$tblData = explode('_',$septd);
				if(!is_array($tableList[$tblData[0]])){
					$tableList[$tblData[0]] = array();
				}
				array_push($tableList[$tblData[0]],$tblData[1]);
			}
		  foreach($tableList as $key=>$val) {
			 $tbl = $this->getTableName($key);
			 $tableName.= $tbl->vc_name.' - '. implode(',',$val) .'<\n>';
		  }
		  
		  $message ="A new booking request has been made at ".$siteName.":<br>Please find the table details.\n ".$tableName." has Booked from ".$date." and ".$time.". Persons Details \n Name: ".$name." \n Email : ".$email."\n Phone : ".$phone."\n No of Person :".$nop . $msgsent;
		  $headers = 'From: '. $name .' <'. $email .'>' . "\r\n" . 'Reply-To: ' . $email . "\r\n";
		  $attachments = '';
		  wp_mail( $to, $subject, $message, $headers, $attachments );
	  
  }
  public function tableBookinList($n,$o,$filters){
	global $wpdb;
	$ord = '';
	$where = "WHERE ";
	$st = " AND is_status!=0";
	if(!empty($n)){
		$ord =  " ORDER BY ".$n.' ' .$o;
	}	
	if(!empty($filters)){
		if($filters['status']!=''){
			$where.= " is_status = '".$filters['status']."'";
		 } else { 
			$where.= " is_status !=0";
		 }
		if(!empty($filters['dt1']) && !empty($filters['dt2'])){
			$where.= " AND dt_date BETWEEN '".date('Y-m-d',strtotime($filters['dt1']))."' AND '".date('Y-m-d',strtotime($filters['dt2']))."' ";
		}
	   if(!empty($filters['tm1'])){
			$where.= " AND vc_time = '".$filters['tm1']."'";
		  }
			
	} else {
		$where.= " dt_date BETWEEN '".date('Y-m-d')."' AND '".date('Y-m-d')."' " .$st;
	}
	 $results = $wpdb->get_results("SELECT * FROM ".$wpdb->prefix.$this->table_booking." ".$where." ".$ord);
	//print_r($wpdb->last_query);
	return $results;
  }
  
  public function updatebookingStatus($id){
	  global $wpdb;
		$result = $wpdb->get_row("UPDATE ".$wpdb->prefix.$this->table_list." SET is_status = 1 WHERE id = ".(int)$id);
		//print_r($wpdb->last_query);
		return $result;
  }
  
   public function getTableName($tid){
	  global $wpdb;
		$result = $wpdb->get_row("SELECT * FROM ".$wpdb->prefix.$this->table_list." WHERE id = ".(int)$tid);
		//print_r($wpdb->last_query);
		return $result;
  }
  public function tableBookingRow($id){
	global $wpdb;
	 $result = $wpdb->get_row("SELECT * FROM ".$wpdb->prefix.$this->table_booking." WHERE id = ".$id);
	//print_r($wpdb->last_query);
	return $result;
  }
  
 public function default_values($m){
		$default['conf_sub'] = 'Your Booking at Table is Confirmed.';
		$default['conf_msg'] = 'Hi {user_name},
										We would be glad to reserve a table for you at our restaurant . Your booking request has been confirmed. We look forward to seeing you soon. 
										Your booking:
										{Table_details}
										Date:  {DATE}
										Time: {TIME}
										{No_of_Person} people
																			
										This message was sent by {site_link} on {current_time}.';
	 $default['rejected_sub'] = 'Your Booking at Table was not accepted.';
	 $default['rejected_msg'] = 'Hi {user_name},
										Sorry,we could not accomodate your booking request. We are could not proccess your request.
										{Table_details}
										Date:  {DATE}
										Time: {TIME}
										{No_of_Person} people
																			
										This message was sent by {site_link} on {current_time}.';									
									
      $default['success_msg'] = 'Thanks, your booking request is confirmed. Updates will be sent to the email address you provide.';	
      $default['opnTime'] = '09:30:AM';	
      $default['endTime'] = '09:30:PM';	
      $default['timeIntval'] = '30';	  
      $default['aut_conf'] = '1';
      if(!empty($m)){	  
			return 	$default[$m];
	  } else {
		  return 	$default;
	  }	
   } 
  public function getdefaultsval($opt){
	  $getdefval = unserialize(get_option('rbytb_default'));
	  if(!empty($opt)){
		return $getdefval[$opt];
	  }	  
  }
  
  public function getReportDownload(){
	$data = array(
    array("firstname" => "Mary", "lastname" => "Johnson", "age" => 25),
	
    array("firstname" => "Amanda", "lastname" => "Miller", "age" => 18),
    array("firstname" => "James", "lastname" => "Brown", "age" => 31),
    array("firstname" => "Patricia", "lastname" => "Williams", "age" => 7),
    array("firstname" => "Michael", "lastname" => "Davis", "age" => 43),
    array("firstname" => "Sarah", "lastname" => "Miller", "age" => 24),
    array("firstname" => "Patrick", "lastname" => "Miller", "age" => 27)
  );

  // file name for download
  $filename = "website_data_" . date('Ymd') . ".xls";

  header("Content-Disposition: attachment; filename=\"$filename\"");
  header("Content-Type: application/vnd.ms-excel");

  $flag = false;
  foreach($data as $row) {
    if(!$flag) {
      // display field/column names as first row
      echo implode("\t", array_keys($row)) . "\n";
      $flag = true;
    }
    array_walk($row,"cleanData");
    echo implode("\t", array_values($row)) . "\n";
  }
exit;
  }
   
 }
}